// Agent broker in project infinite2.mas2j

/* Initial beliefs and rules */

initial_offer(c, orange, 11). // To make 4 cycles in offers and counter-offers
acceptable_offer(c, orange, 6).

/* Initial goals */

/* Plans */

+item(Client, Item)[source(s)] : initial_offer(Client, Item, Offer) 
   <- +current_offer(Client, Item, Offer); 
      !my_send(Client, tell, offer(Item, Offer)).

// BUG 3: comment all the three plans below
@c1[atomic]
+counter(Item, Offer)[source(Client)] : acceptable_offer(Client, Item, Min) 
      & current_offer(Client, Item, Current) & Offer < Min & Offer > Min-4 
   <- !decrease(Client, Item, NewOffer); 
      !my_send(Client, tell, offer(Item, NewOffer)).

@c2[atomic]
+counter(Item, Offer)[source(Client)] : acceptable_offer(Client, Item, Min) 
      & current_offer(Client, Item, Current) & Offer <= Min-4  
   <- !my_send(Client, tell, result(noDeal, Item, Offer)); 
      !my_send(s, tell, final(noDeal, Client, Item, Offer)).

+counter(Item, Offer)[source(Client)] : acceptable_offer(Client, Item, Min) 
      & Offer>=Min 
   <- !my_send(Client, tell, result(ok, Item, Offer)); 
      !my_send(s, tell, final(ok, Client, Item, Offer)). 

+!decrease(Client, Item, NewOffer) : current_offer(Client, Item, Current) 
      & NewOffer = Current-1 
   <- -current_offer(Client, Item, Current); 
      +current_offer(Client, Item, NewOffer).


/* Plans for runtime type checking */

{include("./_session_tools_brokering.asl")}
