// Agent client in project infinite2.mas2j

/* Initial beliefs and rules */

initial_counter_offer(b, orange, 3).
// initial_counter_offer(b, orange, 5).
// initial_counter_offer(b, orange, 4).
// initial_counter_offer(b, orange, 5).
// initial_counter_offer(b, orange, 6).

/* Initial goals */

// !start.

/* Plans */

+offer(Item, Offer)[source(Buyer)] : initial_counter_offer(Buyer, Item, Initial) 
   <-  -initial_counter_offer(Buyer, Item, Initial); 
       -offer(Item, Offer)[source(Buyer)]; 
       +current_counter_offer(Buyer, Item, Initial); 
       !my_send(Buyer, tell, counter(Item, Initial)).

// Plan for session compliant behaviour
+offer(Item, Offer)[source(Buyer)] : true 
   <- -offer(Item, Offer)[source(Buyer)]; 
      !increase(Buyer, Item, NewOffer); 
      !my_send(Buyer, tell, counter(Item, NewOffer)). 

// Plan for non session compliant behaviour, BUG1
/* +offer(Item, Offer)[source(Buyer)] : true 
    <- -offer(Item, Offer)[source(Buyer)];  
       !increase(Buyer, Item, NewOffer); 
       !my_send(Buyer, tell, offer(Item, NewOffer));
	   !my_send(Buyer, tell, anotherOffer(Item, NewOffer)). */

// Plan for non session compliant behaviour, BUG2 (uncomment initial goal)   
/* +!start : initial_counter_offer(Buyer, Item, Initial) 
   <-  -initial_counter_offer(Buyer, Item, Initial); 
       +current_counter_offer(Buyer, Item, Initial); 
       !my_send(Buyer, tell, counter(Item, Initial)). */ 	   
	   
+result(Res, Item, Offer)[source(Buyer)]: true.

+!increase(Client, Item, NewOffer) : current_counter_offer(Client, Item, Current) 
       & NewOffer = Current+1 
   <- -current_counter_offer(Client, Item, Current); 
      +current_counter_offer(Client, Item, NewOffer).


/* Plans for runtime type checking */

{include("./_session_tools_brokering.asl")}
