// Agent client in project infinite2.mas2j

/* Initial beliefs and rules */

initial_counter_offer(b_conv, orange, 3).
// initial_counter_offer(b_conv, orange, 5).
// initial_counter_offer(b_conv, orange, 4).
// initial_counter_offer(b_conv, orange, 5).
// initial_counter_offer(b_conv, orange, 6).

/* Initial goals */

// !start.

/* Plans */

+m(offer(Item, Offer), CId)[source(Buyer)] : initial_counter_offer(Buyer, Item, Initial) 
   <-  -initial_counter_offer(Buyer, Item, Initial); 
       -offer(Item, Offer)[source(Buyer)]; 
       +current_counter_offer(Buyer, Item, Initial); 
	   .print("\n1a\n");
       !my_send(Buyer, tell, m(counter(Item, Initial), CId)); .print("\n1b\n").

// Plan for session compliant behaviour
+m(offer(Item, Offer), CId)[source(Buyer)] : true 
   <- -offer(Item, Offer)[source(Buyer)]; 
      !increase(Buyer, Item, NewOffer);
	  .print("\n2a\n");
      !my_send(Buyer, tell, m(counter(Item, NewOffer), CId)); .print("\n2b\n"). 

// Plan for non session compliant behaviour, BUG1
/* +m(offer(Item, Offer), CId)[source(Buyer)] : true 
    <- -offer(Item, Offer)[source(Buyer)];  
       !increase(Buyer, Item, NewOffer); 
       !my_send(Buyer, tell, m(offer(Item, NewOffer), CId));
	   !my_send(Buyer, tell, m(anotherOffer(Item, NewOffer), CId)). */

// Plan for non session compliant behaviour, BUG2 (uncomment initial goal)   
/* +!start : initial_counter_offer(Buyer, Item, Initial) 
   <-  -initial_counter_offer(Buyer, Item, Initial); 
       +current_counter_offer(Buyer, Item, Initial); 
       !my_send(Buyer, tell, m(counter(Item, Initial), s(0))). */ 	   
	   
+m(result(Res, Item, Offer), CId)[source(Buyer)]: true.

+!increase(Client, Item, NewOffer) : current_counter_offer(Client, Item, Current) 
       & NewOffer = Current+1 
   <- -current_counter_offer(Client, Item, Current); 
      +current_counter_offer(Client, Item, NewOffer).


/* Plans for runtime type checking */

{include("./_session_tools_brokering_conv.asl")}
