/* Code implemented by Davide on Jan 26 2013, to test the examples in the Fundamenta Informaticae paper */

has_type(X, X).

/* next(0,seq(sa(AType,N),T),AMessage,T,N) :- has_type(AMessage, AType).
next(M,seq(A,T1),A,T1,N) :- M > 0, N = M - 1.
next(M,choice([T1,_]),A,T2,N) :- next(M,T1,A,T2,N). 
next(M,choice([_,T1]),A,T2,N) :- next(M,T1,A,T2,N).
next(N,fork(T1,T2),A,fork(T3,T2),M) :- next(N,T1,A,T3,M). 
next(N,fork(T1,T2),A,fork(T1,T3),M) :- next(N,T2,A,T3,M).
next(N,fork(T1,T2),A,fork(T3,T4),P) :- next(N,T1,A,T3,M) & M > 0 & next(M,T2,A,T4,P). 
next(N,fork(T1,T2),A,fork(T4,T3),P) :- next(N,T2,A,T3,M) & M > 0 & next(M,T1,A,T4,P). 
next(M,cat(T1,T2),A,cat(T3,T2),N) :- next(M,T1,A,T3,N).
next(M,cat(T1,T2),A,T3,N) :- empty(T1) & next(M,T2,A,T3,N).

empty(lambda).
empty(choice([T1,_])) :- empty(T1).
empty(choice([_,T1])) :- empty(T1).
empty(fork(T1,T2)) :- empty(T1) & empty(T2).
empty(cat(T1,T2)) :- empty(T1) & empty(T2).

accept(T1,[A|L]) :- next(0,T1,A,T2,0) & accept(T2,L).
accept(T,[]) :- empty(T).

accept(_,T,[*]) :- empty(T).
accept(0,T,[]).
accept(N,T1,[A|L]) :- N > 0 & next(0,T1,A,T2,0) & M = N - 1 & accept(M,T2,L). */

next(0,seq(sa(AType,N),T),AMessage,T,N) :- has_type(AMessage, AType).
next(M,seq(sa(AType),T1),AMessage,T1,N) :- M > 0, N is M - 1, has_type(AMessage, AType).
next(M,choice([T1,_]),A,T2,N) :- next(M,T1,A,T2,N). 
next(M,choice([_,T1]),A,T2,N) :- next(M,T1,A,T2,N).
next(N,fork(T1,T2),A,fork(T3,T2),M) :- next(N,T1,A,T3,M). 
next(N,fork(T1,T2),A,fork(T1,T3),M) :- next(N,T2,A,T3,M).
next(N,fork(T1,T2),A,fork(T3,T4),P) :- next(N,T1,A,T3,M) , M > 0 , next(M,T2,A,T4,P). 
next(N,fork(T1,T2),A,fork(T4,T3),P) :- next(N,T2,A,T3,M) , M > 0 , next(M,T1,A,T4,P). 
next(M,cat(T1,T2),A,cat(T3,T2),N) :- next(M,T1,A,T3,N).
next(M,cat(T1,T2),A,T3,N) :- empty(T1) , next(M,T2,A,T3,N).

empty(lambda).
empty(choice([T1,_])) :- empty(T1).
empty(choice([_,T1])) :- empty(T1).
empty(fork(T1,T2)) :- empty(T1) , empty(T2).
empty(cat(T1,T2)) :- empty(T1) , empty(T2).

accept(T1,[A|L]) :- next(0,T1,A,T2,0) , accept(T2,L).
accept(T,[]) :- empty(T).

accept(_,T,[*]) :- empty(T).
accept(0,_,[]).
accept(N,T1,[A|L]) :- N > 0, next(0,T1,A,T2,0) , M is N - 1 , accept(M,T2,L). 

%testFinAltBit(N) :- open('altBit2.txt',write,Str),M1M2=lambda+(m1:(lambda+(m2:(lambda+M1M2)))),M1A1=lambda+((m1,1):(lambda+((a1,0):(lambda+M1A1)))),M2A2=lambda+((m2,1):(lambda+((a2,0):(lambda+M2A2)))),T=(M1M2|M1A1|M2A2),length(IL,N),setof(IL,accept(T,IL),OL),write(OL),print_list(Str,OL),close(Str).

testFinAltBit(N) :- 
open('altBit2_v.txt',write,Str),
M1M2=seq(sa(m1), seq(sa(m2), M1M2)),
M1A1=seq(sa(m1,1),seq(sa(a1,0),M1A1)),
M2A2=seq(sa(m2,1),seq(sa(a2,0),M2A2)),
T=fork(M1M2, fork(M1A1,M2A2)),
write(T),
setof(IL,accept(N,T,IL),OL),write(OL),print_list(Str,OL),close(Str).

%testFinAltBit3(N) :- open('altBit3.txt',write,Str),M1M2M3=lambda+(m1:(lambda+(m2:(lambda+(m3:(lambda+M1M2M3)))))),M1A1=lambda+((m1,1):(lambda+((a1,0):(lambda+M1A1)))),M2A2=lambda+((m2,1):(lambda+((a2,0):(lambda+M2A2)))),M3A3=lambda+((m3,1):(lambda+((a3,0):(lambda+M3A3)))),T=((M1M2M3|M1A1)|(M2A2|M3A3)),length(IL,N),setof(IL,accept(T,IL),OL),write(OL),print_list(Str,OL),close(Str).

testFinAltBit3(N) :- open('altBit3_v.txt',write,Str),
M1M2M3=seq(sa(m1),seq(sa(m2),seq(sa(m3),M1M2M3))), 
M1A1=seq(sa(m1,1), seq(sa(a1,0), M1A1)),
M2A2=seq(sa(m2,1), seq(sa(a2,0), M2A2)),
M3A3=seq(sa(m3,1), seq(sa(a3,0), M3A3)),
T=fork(fork(M1M2M3,M1A1),fork(M2A2,M3A3)),
setof(IL,accept(N,T,IL),OL),write(OL),print_list(Str,OL),close(Str).


testFinAnBn(N) :- open('anbn_v.txt',write,Str),
T = cat(AB, Forever),
AB = seq(sa(msg(alice_complex, bob_complex, tell, a), 0),
        choice([append(AB, seq(sa(msg(bob_complex, alice_complex, tell, b), 0),lambda)), seq(sa(msg(bob_complex, alice_complex, tell, b), 0),lambda)])).
setof(IL,accept(N,T,IL),OL),write(OL),print_list(Str,OL),close(Str).


%%% the following two types are equivalent

testFinAltBitOr3(N) :- open('altBitOr3.txt',write,Str),M1M2M3=lambda+(m1:(lambda+(m2:(lambda+(m3:M1M2M3))))),M1A1=lambda+((m1,1):(lambda+((a1,1):M1A1))),M2A2=lambda+((m2,1):(lambda+((a2,1):M2A2))),M3A3=lambda+((m3,2):(lambda+((a3,0):M3A3))),AM=lambda+((a1:(lambda+(m3:AM)))+(a2:(lambda+(m3:AM)))),T=((M1A1|M2A2)|(M3A3|M1M2M3)|AM),length(IL,N),setof(IL,accept(T,IL),OL),write(OL),print_list(Str,OL),close(Str).

testFinAltBitOr3bis(N) :- open('altBitOr3bis.txt',write,Str),M1M2M3=lambda+(m1:(lambda+(m2:(lambda+(m3:(lambda+M1M2M3)))))),M1A1=lambda+((m1,1):(lambda+((a1,1):(lambda+M1A1)))),M2A2=lambda+((m2,1):(lambda+((a2,1):(lambda+M2A2)))),M3A3=lambda+((m3,2):(lambda+((a3,0):(lambda+M3A3)))),AMbis=lambda+(((a1:lambda)+(a2:lambda))*(lambda+(m3:(lambda+AMbis)))),T=((M1A1|M2A2)|(M3A3|M1M2M3)|AMbis),length(IL,N),setof(IL,accept(T,IL),OL),write(OL),print_list(Str,OL),close(Str).

%%% the following two types are equivalent

testFinAltBitAnd3(N) :- open('altBitAnd3.txt',write,Str),M1M2M3=lambda+(m1:(lambda+(m2:(lambda+(m3:M1M2M3))))),M1A1=lambda+((m1,1):(lambda+((a1,1):M1A1))),M2A2=lambda+((m2,1):(lambda+((a2,1):M2A2))),M3A3=lambda+((m3,3):(lambda+((a3,0):M3A3))),AM=((lambda+(a1:(lambda+(m3:AM))))|(lambda+(a2:(lambda+(m3:AM))))),T=((M1A1|M2A2)|(M3A3|M1M2M3)|AM),length(IL,N),setof(IL,accept(T,IL),OL),write(OL),print_list(Str,OL),close(Str).

testFinAltBitAnd3bis(N) :- open('altBitAnd3bis.txt',write,Str),M1M2M3=lambda+(m1:(lambda+(m2:(lambda+(m3:M1M2M3))))),M1A1=lambda+((m1,1):(lambda+((a1,1):M1A1))),M2A2=lambda+((m2,1):(lambda+((a2,1):M2A2))),M3A3=lambda+((m3,2):(lambda+((a3,0):M3A3))),AMbis=lambda+(((a1:lambda)|(a2:lambda))*(lambda+(m3:(lambda+AMbis)))),T=((M1A1|M2A2)|(M3A3|M1M2M3)|AMbis),length(IL,N),setof(IL,accept(T,IL),OL),write(OL),print_list(Str,OL),close(Str).

gen(N1,N2,N1) :- N1 =< N2.
gen(N1,N2,N) :- N1 < N2, N3 is N1 + 1, gen(N3,N2,N).

%%% the following two types are equivalent

testAfter3times(N) :- open('after3times.txt',write,Str),T=(offer,0):(offer,0):(offer,0):S,S = ((buy,0):lambda)+((offer,0):S),setof(IL,M^(gen(0,N,M),length(IL,M),accept(T,IL)),OL),write(OL),print_list(Str,OL),close(Str).  

testAfter3timesGen(N) :- open('after3timesGen.txt',write,Str),T=((S1 * ((buy,3):lambda)) | S2), S1 = lambda+((offer,0):S1)+((offer,1):S1), S2 = ( lambda + (offer:((buy:lambda) | S2))),setof(IL,M^(gen(0,N,M),length(IL,M),accept(T,IL)),OL),write(OL),print_list(Str,OL),close(Str).  

print_list(_,[]).
print_list(S,[X|L]) :- write(S,X),write(S,'\n'),print_list(S,L).

% next(0, seq(sa(m1, 1), seq(sa(a1, 0), **)), _G491, _G497, 0)
