// Agent broker in project infinite2.mas2j

/* Initial beliefs and rules */

initial_offer(c_conv, orange, 11). // To make 4 cycles in offers and counter-offers
acceptable_offer(c_conv, orange, 6).

/* Initial goals */

/* Plans */

+m(item(Client, Item), CId)[source(s_conv)] : .print(m(item(Client, Item), CId)[source(s_conv)]) & initial_offer(Client, Item, Offer) 
   <- +current_offer(Client, Item, Offer); 
      !my_send(Client, tell, m(offer(Item, Offer), CId)).

// BUG 3: comment all the three plans below
@c1[atomic]
+m(counter(Item, Offer), CId)[source(Client)] : acceptable_offer(Client, Item, Min) 
      & current_offer(Client, Item, Current) & Offer < Min & Offer > Min-4 
   <- !decrease(Client, Item, NewOffer); 
      !my_send(Client, tell, m(offer(Item, NewOffer), CId)).

@c2[atomic]
+m(counter(Item, Offer), CId)[source(Client)] : acceptable_offer(Client, Item, Min) 
      & current_offer(Client, Item, Current) & Offer <= Min-4  
   <- !my_send(Client, tell, m(result(noDeal, Item, Offer), CId)); 
      !my_send(s_conv, tell, m(final(noDeal, Client, Item, Offer), CId)).

+m(counter(Item, Offer), CId)[source(Client)] : acceptable_offer(Client, Item, Min) 
      & Offer>=Min 
   <- !my_send(Client, tell, m(result(ok, Item, Offer), CId)); 
      !my_send(s_conv, tell, m(final(ok, Client, Item, Offer), CId)). 

+!decrease(Client, Item, NewOffer) : current_offer(Client, Item, Current) 
      & NewOffer = Current-1 
   <- -current_offer(Client, Item, Current); 
      +current_offer(Client, Item, NewOffer).


/* Plans for runtime type checking */

{include("./_session_tools_brokering_conv.asl")}
