// Brokering configuration

ico(b1, orange, 7).
ico(b2, orange, 9).
ico(_, orange, 5).
io(c1, orange, 11).
io(_, orange, 12).
ao(c1, orange, 6).
ao(_, orange, 7).

/* Initial beliefs */

min(1).
max(100).

generate_list(List) :- 
min(Min) & max(Max) & Sec = Min+1 & //.print(generate_list(List, Max, Sec, [Min])) & 
generate_list(List, Max, Sec, [Min]).

generate_list(List, Max, CurrentVal, CurrentList) :- 
CurrentVal < Max &
.concat(CurrentList,[CurrentVal], Temp) &
NewVal = CurrentVal+1 & // .print(generate_list(List, Max, NewVal, Temp)) &
generate_list(List, Max, NewVal, Temp).

generate_list(List, Max, Max, CurrentList) :-
.concat(CurrentList,[Max],L) & List = L.

create_business_partners(Seller, Broker, Client) :-
.ground(Seller) &
.term2string(Seller, SellerStr) & 
agent_id_list(List) &
.member(List, Term) &
.term2string(Term, X) &
/* .print("bbbbbbbbbbbb") &
gtu.str_conc("s", X, SellerStr) &
.print("cccccccccc") & */
.concat("b", X, BrokerStr) &
.concat("c", X, ClientStr) &
.term2string(Client, ClientStr) &
.term2string(Broker, BrokerStr).

create_business_partners(Seller, Broker, Client) :-
.ground(Broker) &
.term2string(Broker, BrokerStr) & 
agent_id_list(List) &
.member(List, Term) &
.term2string(Term, X) &
.concat("b", X, BrokerStr) &
.concat("s", X, SellerStr) &
.concat("c", X, ClientStr) &
.term2string(Seller, SellerStr) &
.term2string(Client, ClientStr).

create_business_partners(Seller, Broker, Client) :-
.ground(Client) &
.term2string(Client, ClientStr) & 
agent_id_list(List) &
.member(Term, List) &
.term2string(Term, X) &
.concat("c", X, ClientStr) &
.concat("b", X, BrokerStr) &
.concat("s", X, SellerStr) &
.term2string(Seller, SellerStr) &
.term2string(Broker, BrokerStr).

/* Initial goals */

!start_finding_partners.

/* Plans */

+!start_finding_partners : .print("\n1\n") & generate_list(List) <- 
!manage(List).

+!manage(List): 
.my_name(Name) & 
.term2string(Name, NameStr) &
.substring("b",NameStr, 0) <-
+agent_id_list(List);
!find_business_partners(Seller, Name, Client).

+!manage(List): 
.my_name(Name) &
.term2string(Name, NameStr) &
.substring("c",NameStr, 0) <-
+agent_id_list(List);
!find_business_partners(Seller, Broker, Name).

+!manage(List): 
.my_name(Name) &
.term2string(Name, NameStr) &
.substring("s",NameStr, 0) <-
+agent_id_list(List);
!find_business_partners(Name, Broker, Client).

+!find_business_partners(Seller, Broker, Client): create_business_partners(Seller, Broker, Client) <- 
+business_partners(Seller, Broker, Client); !start.

//======================================================================


